import { useMutation } from "@apollo/client/react";
import { Button, Form, Space } from "antd";
import axios from "axios";
import dayjs from "../../utils/day";
import { useMemo, useState } from "react";
import { useTranslation } from "react-i18next";
import { connect } from "react-redux";
import { createStructuredSelector } from "reselect";
import { INSERT_NEW_TIME_TICKET } from "../../graphql/timetickets.queries";
import { selectTechnician } from "../../redux/tech/tech.selectors";
import { selectBodyshop, selectCurrentUser } from "../../redux/user/user.selectors";
import TechJobPrintTickets from "../tech-job-print-tickets/tech-job-print-tickets.component";
import TimeTicektShiftComponent from "./time-ticket-shift-form.component";
import { useNotification } from "../../contexts/Notifications/notificationContext.jsx";

const mapStateToProps = createStructuredSelector({
  currentUser: selectCurrentUser,
  bodyshop: selectBodyshop,
  technician: selectTechnician
});
const mapDispatchToProps = () => ({
  //setUserLanguage: language => dispatch(setUserLanguage(language))
});

export function TimeTicektShiftContainer({ bodyshop, technician, currentUser, isTechConsole, checkIfAlreadyClocked }) {
  console.log("🚀 ~ file: time-ticket-shift-form.container.jsx:28 ~ technician:", technician);
  const [form] = Form.useForm();
  const [insertTimeTicket] = useMutation(INSERT_NEW_TIME_TICKET);
  const { t } = useTranslation();
  const [loading, setLoading] = useState(false);
  const notification = useNotification();

  const employeeId = useMemo(() => {
    const assoc = bodyshop.associations.filter((a) => a.useremail === currentUser.email)[0];

    return assoc?.user && assoc.user.employee && assoc.user.employee.id;
  }, [bodyshop, currentUser.email]);

  const handleFinish = async (values) => {
    setLoading(true);

    const alreadyClocked = await checkIfAlreadyClocked();

    if (alreadyClocked) {
      //Show the error.
      notification.error({
        title: t("timetickets.errors.shiftalreadyclockedon")
      });
    } else {
      const theTime = dayjs((await axios.post("/utils/time")).data);

      const result = await insertTimeTicket({
        variables: {
          timeTicketInput: [
            {
              bodyshopid: bodyshop.id,
              employeeid: isTechConsole ? technician.id : employeeId,
              cost_center: "timetickets.labels.shift",
              clockon: theTime,
              date:
                typeof bodyshop.timezone === "string"
                  ? // TODO: Client Update - This may be broken
                    dayjs.tz(theTime, bodyshop.timezone).format("YYYY-MM-DD")
                  : typeof bodyshop.timezone === "number"
                    ? dayjs(theTime).utcOffset(bodyshop.timezone).format("YYYY-MM-DD")
                    : dayjs(theTime).format("YYYY-MM-DD"),
              memo: values.memo,
              created_by: isTechConsole
                ? currentUser.email.concat(
                    " | ",
                    technician.employee_number.concat(" ", technician.first_name, " ", technician.last_name).trim()
                  )
                : currentUser.displayName
                  ? currentUser.email.concat(" | ", currentUser.displayName)
                  : currentUser.email
            }
          ]
        },
        awaitRefetchQueries: true,
        refetchQueries: ["QUERY_ACTIVE_SHIFT_TIME_TICKETS"]
      });

      if (result.errors) {
        notification.error({
          title: t("timetickets.errors.clockingin", {
            message: JSON.stringify(result.errors)
          })
        });
      } else {
        notification.success({
          title: t("timetickets.successes.clockedin")
        });
      }
    }

    setLoading(false);
  };

  return (
    <div>
      <Form
        form={form}
        layout="vertical"
        autoComplete="no"
        onFinish={handleFinish}
        initialValues={{ cost_center: t("timetickets.labels.shift") }}
      >
        <TimeTicektShiftComponent form={form} />
        <Space wrap>
          <Button htmlType="submit" loading={loading} type="primary">
            {t("timetickets.actions.clockin")}
          </Button>
          {isTechConsole === true ? <TechJobPrintTickets attendacePrint={true} /> : null}
        </Space>
      </Form>
    </div>
  );
}

export default connect(mapStateToProps, mapDispatchToProps)(TimeTicektShiftContainer);
